// C Source File
// Created 1/26/2004; 09.03.35

#ifndef _WALL_C_
#define _WALL_C_

#include "wall.h"
#include "utils.h"

int placeWall(Wall *wall, short *numWalls, Player *player, int numPlayers, short size)
{
	char done = 0;
	
	int key;

	int r=1, c=1, i, row, col;
	
	WallDirection dir = HORIZONTAL;

	sendMessage("Press MODE to flip wall, ENTER to place");

	while (!done)
	{
		drawWall(r, c, dir, A_XOR);	
		key = ngetchx();
		drawWall(r, c, dir, A_XOR);
		
		if (key == KEY_LEFT && c > 1)
			c--;
		if (key == KEY_RIGHT && c < size-1)
			c++;

		if (key == KEY_UP && r > 1)
			r--;
		if (key == KEY_DOWN && r < size-1)
			r++;

		if (key == KEY_MODE)
			dir = !dir;
			
		if (key == KEY_ENTER) {

			sendMessage("Checking...");

			done = 1;
			
			for (i=0; i<*numWalls; i++)
			{
				if (wall[i].r == r && wall[i].c == c)
					done = 0;
					
				if (dir == HORIZONTAL && wall[i].dir == HORIZONTAL && c <= wall[i].c+1 && c >= wall[i].c-1 && wall[i].r == r)
						done = 0;
	
				if (dir == VERTICAL && wall[i].dir == VERTICAL && r <= wall[i].r+1 && r >= wall[i].r-1 && wall[i].c == c)
						done = 0;

				if (done == 0) {
					sendMessage("Invalid wall placement (blocked by another wall)");
					break;
				}
			}
			
			for (i=0; i<numPlayers; i++)
			{
				Grid grid;
				for (row=0; row<size; row++)
					for (col=0; col<size; col++)
						grid.data[row][col] = 0;

				wall[*numWalls].r = r;
				wall[*numWalls].c = c;
				wall[*numWalls].dir = dir;

				*numWalls += 1;
	
				char test = 0;
				isWinPossible(&test, &grid, &size, wall, numWalls, player[i].r, player[i].c, &player[i].desiredR, &player[i].desiredC);
				
				*numWalls -= 1;
				
				if (!test)
					done = 0;
				
				if (test == 0)
					sendMessage("Invalid wall placement (blocks opponent)");
			}
		
		}
		
		if (key == KEY_ESC) {
			sendMessage("");
			return 1;
		}
		
	}
	
	wall[*numWalls].r = r;
	wall[*numWalls].c = c;
	wall[*numWalls].dir = dir;

	drawWall(wall[*numWalls].r, wall[*numWalls].c, wall[*numWalls].dir, A_NORMAL);
	
	*numWalls = *numWalls + 1;

	sendMessage("");
	return 0;
}

void drawWall(int r, int c, WallDirection dir, short Attr)
{
	int x = BOARDOFFSET_X;
	int y = BOARDOFFSET_Y;

	SetPlane(1);
	if (dir == HORIZONTAL)
		DrawLine(c*CELL_WIDTH+x-CELL_WIDTH, r*CELL_WIDTH+y, c*CELL_WIDTH+x+CELL_WIDTH, r*CELL_WIDTH+y, Attr);
	if (dir == VERTICAL)
		DrawLine(c*CELL_WIDTH+x, r*CELL_WIDTH+y-CELL_WIDTH, c*CELL_WIDTH+x, r*CELL_WIDTH+y+CELL_WIDTH, Attr);

}

int testMove(const Wall *walls, const int numWalls, const int size, const int r, const int c, const int moveR, const int moveC)
{
	int newlocR = r + moveR;
	int	newlocC = c + moveC;

	//first check out of bounds errors	
	if (newlocR < 0 || newlocC < 0 || newlocR >= size || newlocC >= size) {
		return 0;
	}
	
	int i;
	
	for (i=0; i<numWalls; i++)
	{
		if (moveR != 0 && walls[i].dir == HORIZONTAL) {
			if ((c == walls[i].c-1 || c == walls[i].c) 
			&& ((newlocR == walls[i].r && r == walls[i].r-1) || (newlocR == walls[i].r-1 && r == walls[i].r))) {
					return 0;
				}
		}
		
		if (moveC != 0 && walls[i].dir == VERTICAL) {
			if ((r == walls[i].r-1 || r == walls[i].r) 
			&& ((newlocC == walls[i].c && c == walls[i].c-1) || (newlocC == walls[i].c-1 && c == walls[i].c))) {
					return 0;
				}
		}
	}
	
	return 1;
}



#endif
